using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Linq;
using Crestron;
using Crestron.Logos.SplusLibrary;
using Crestron.Logos.SplusObjects;
using Crestron.SimplSharp;

namespace UserModule_EPISODE_EA_RSP_V1_1
{
    public class UserModuleClass_EPISODE_EA_RSP_V1_1 : SplusObject
    {
        static CCriticalSection g_criticalSection = new CCriticalSection();
        
        
        InOutArray<Crestron.Logos.SplusObjects.DigitalInput> SELECT_OUTPUT;
        InOutArray<Crestron.Logos.SplusObjects.DigitalInput> SELECT_INPUT;
        InOutArray<Crestron.Logos.SplusObjects.DigitalInput> OUTPUT_VOLUME_UP;
        InOutArray<Crestron.Logos.SplusObjects.DigitalInput> OUTPUT_VOLUME_DOWN;
        InOutArray<Crestron.Logos.SplusObjects.DigitalInput> MUTE_OUTPUT;
        InOutArray<Crestron.Logos.SplusObjects.AnalogInput> SET_OUTPUT_VOLUME;
        InOutArray<Crestron.Logos.SplusObjects.AnalogOutput> OUTPUT_SOURCE;
        InOutArray<Crestron.Logos.SplusObjects.AnalogOutput> OUTPUT_VOLUME;
        SplusTcpClient CLIENT;
        StringParameter IP_ADDRESS;
        StringParameter USERNAME;
        StringParameter PASSWORD;
        ushort G_SELECTED_OUTPUT = 0;
        ushort G_SELECTED_INPUT = 0;
        ushort [] G_OUTPUT_MUTE;
        short G_CONNECTIONSTATUS = 0;
        short G_SOCKETSTATUS = 0;
        private CrestronString MAKECMD (  SplusExecutionContext __context__, CrestronString TYPE , CrestronString JSON ) 
            { 
            CrestronString RESULT;
            RESULT  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1024, this );
            
            
            __context__.SourceCodeLine = 149;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( Functions.Length( JSON ) < 1 ))  ) ) 
                { 
                __context__.SourceCodeLine = 150;
                MakeString ( RESULT , "{{\"type\":\"{0}\"}}", TYPE ) ; 
                } 
            
            else 
                { 
                __context__.SourceCodeLine = 152;
                MakeString ( RESULT , "{{\"type\":\"{0}\",{1}}}", TYPE , JSON ) ; 
                } 
            
            __context__.SourceCodeLine = 155;
            return ( RESULT ) ; 
            
            }
            
        private CrestronString MAKEKVPAIRNOQUOTES (  SplusExecutionContext __context__, CrestronString KEY , CrestronString VALUE ) 
            { 
            CrestronString RESULT;
            RESULT  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 512, this );
            
            
            __context__.SourceCodeLine = 162;
            MakeString ( RESULT , "\"{0}\":{1}", KEY , VALUE ) ; 
            __context__.SourceCodeLine = 164;
            return ( RESULT ) ; 
            
            }
            
        private CrestronString MAKEKVPAIR (  SplusExecutionContext __context__, CrestronString KEY , CrestronString VALUE ) 
            { 
            CrestronString QUOTEV;
            QUOTEV  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 512, this );
            
            
            __context__.SourceCodeLine = 171;
            MakeString ( QUOTEV , "\"{0}\"", VALUE ) ; 
            __context__.SourceCodeLine = 173;
            return ( MAKEKVPAIRNOQUOTES (  __context__ , KEY, QUOTEV) ) ; 
            
            }
            
        private CrestronString MAKEKVPAIRINT (  SplusExecutionContext __context__, CrestronString KEY , ushort VALUE ) 
            { 
            CrestronString RESULT;
            RESULT  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 512, this );
            
            
            __context__.SourceCodeLine = 180;
            MakeString ( RESULT , "\"{0}\":{1:d}", KEY , (short)VALUE) ; 
            __context__.SourceCodeLine = 182;
            return ( RESULT ) ; 
            
            }
            
        private ushort GETINT (  SplusExecutionContext __context__, CrestronString DATA , CrestronString VALUE ) 
            { 
            ushort IT = 0;
            
            CrestronString JUNK;
            JUNK  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 128, this );
            
            CrestronString COPY;
            COPY  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1024, this );
            
            
            __context__.SourceCodeLine = 191;
            SetString ( DATA , (int)1, COPY ) ; 
            __context__.SourceCodeLine = 193;
            IT = (ushort) ( Functions.Find( VALUE , COPY ) ) ; 
            __context__.SourceCodeLine = 195;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (IT == 0))  ) ) 
                {
                __context__.SourceCodeLine = 196;
                return (ushort)( Functions.ToInteger( -( 1 ) )) ; 
                }
            
            __context__.SourceCodeLine = 198;
            JUNK  .UpdateValue ( Functions.Remove ( VALUE , COPY )  ) ; 
            __context__.SourceCodeLine = 199;
            JUNK  .UpdateValue ( Functions.Remove ( ":" , COPY )  ) ; 
            __context__.SourceCodeLine = 201;
            IT = (ushort) ( Functions.Find( "," , COPY ) ) ; 
            __context__.SourceCodeLine = 203;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( IT > 0 ))  ) ) 
                { 
                __context__.SourceCodeLine = 204;
                return (ushort)( Functions.Atoi( Functions.Left( COPY , (int)( (IT - 1) ) ) )) ; 
                } 
            
            else 
                { 
                __context__.SourceCodeLine = 206;
                return (ushort)( Functions.Atoi( Functions.Left( COPY , (int)( (Functions.Length( COPY ) - 1) ) ) )) ; 
                } 
            
            
            return 0; // default return value (none specified in module)
            }
            
        private CrestronString GETVALUE (  SplusExecutionContext __context__, CrestronString DATA , CrestronString VALUE ) 
            { 
            ushort IT = 0;
            
            CrestronString JUNK;
            JUNK  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 128, this );
            
            CrestronString COPY;
            COPY  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1024, this );
            
            
            __context__.SourceCodeLine = 216;
            SetString ( DATA , (int)1, COPY ) ; 
            __context__.SourceCodeLine = 218;
            IT = (ushort) ( Functions.Find( VALUE , COPY ) ) ; 
            __context__.SourceCodeLine = 220;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (IT == 0))  ) ) 
                {
                __context__.SourceCodeLine = 221;
                return ( "" ) ; 
                }
            
            __context__.SourceCodeLine = 223;
            JUNK  .UpdateValue ( Functions.Remove ( VALUE , COPY )  ) ; 
            __context__.SourceCodeLine = 224;
            JUNK  .UpdateValue ( Functions.Remove ( ":" , COPY )  ) ; 
            __context__.SourceCodeLine = 225;
            IT = (ushort) ( Functions.GetC( COPY ) ) ; 
            __context__.SourceCodeLine = 227;
            IT = (ushort) ( Functions.Find( "\"" , COPY ) ) ; 
            __context__.SourceCodeLine = 229;
            return ( Functions.Left ( COPY ,  (int) ( (IT - 1) ) ) ) ; 
            
            }
            
        private CrestronString GETOBJECT (  SplusExecutionContext __context__, CrestronString DATA , CrestronString VALUE ) 
            { 
            ushort IT = 0;
            
            CrestronString START;
            START  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 2, this );
            
            CrestronString END;
            END  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 2, this );
            
            CrestronString JUNK;
            JUNK  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 128, this );
            
            CrestronString COPY;
            COPY  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1024, this );
            
            
            __context__.SourceCodeLine = 240;
            SetString ( DATA , (int)1, COPY ) ; 
            __context__.SourceCodeLine = 242;
            IT = (ushort) ( Functions.Find( VALUE , COPY ) ) ; 
            __context__.SourceCodeLine = 244;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (IT == 0))  ) ) 
                {
                __context__.SourceCodeLine = 245;
                return ( "" ) ; 
                }
            
            __context__.SourceCodeLine = 247;
            JUNK  .UpdateValue ( Functions.Remove ( VALUE , COPY )  ) ; 
            __context__.SourceCodeLine = 248;
            JUNK  .UpdateValue ( Functions.Remove ( ":" , COPY )  ) ; 
            __context__.SourceCodeLine = 251;
            MakeString ( START , "{0}", Functions.Left ( COPY ,  (int) ( 1 ) ) ) ; 
            __context__.SourceCodeLine = 254;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (START == "{"))  ) ) 
                { 
                __context__.SourceCodeLine = 255;
                END  .UpdateValue ( "}"  ) ; 
                } 
            
            else 
                {
                __context__.SourceCodeLine = 256;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt (START == "["))  ) ) 
                    { 
                    __context__.SourceCodeLine = 257;
                    END  .UpdateValue ( "]"  ) ; 
                    } 
                
                else 
                    { 
                    __context__.SourceCodeLine = 259;
                    return ( "" ) ; 
                    } 
                
                }
            
            __context__.SourceCodeLine = 265;
            IT = (ushort) ( Functions.Find( END , COPY ) ) ; 
            __context__.SourceCodeLine = 267;
            while ( Functions.TestForTrue  ( ( Functions.BoolToInt ( (Functions.TestForTrue ( Functions.BoolToInt (Functions.Find( START , COPY , IT ) != 0) ) && Functions.TestForTrue ( Functions.BoolToInt ( IT > Functions.Find( START , COPY , IT ) ) )) ))  ) ) 
                { 
                __context__.SourceCodeLine = 269;
                IT = (ushort) ( Functions.Find( END , COPY , (IT + 1) ) ) ; 
                __context__.SourceCodeLine = 267;
                } 
            
            __context__.SourceCodeLine = 272;
            return ( Functions.Left ( COPY ,  (int) ( IT ) ) ) ; 
            
            }
            
        private ushort GETARRAYCOUNT (  SplusExecutionContext __context__, CrestronString ARRAY ) 
            { 
            ushort IT = 0;
            
            ushort COUNT = 0;
            
            
            __context__.SourceCodeLine = 283;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (Functions.Left( ARRAY , (int)( 1 ) ) != "["))  ) ) 
                { 
                __context__.SourceCodeLine = 284;
                return (ushort)( Functions.ToInteger( -( 1 ) )) ; 
                } 
            
            else 
                {
                __context__.SourceCodeLine = 285;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt (Functions.Right( ARRAY , (int)( 1 ) ) != "]"))  ) ) 
                    { 
                    __context__.SourceCodeLine = 286;
                    return (ushort)( Functions.ToInteger( -( 1 ) )) ; 
                    } 
                
                }
            
            __context__.SourceCodeLine = 289;
            IT = (ushort) ( Functions.Find( "}," , ARRAY ) ) ; 
            __context__.SourceCodeLine = 291;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (IT == 0))  ) ) 
                { 
                __context__.SourceCodeLine = 292;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( Functions.Length( ARRAY ) > 2 ))  ) ) 
                    {
                    __context__.SourceCodeLine = 293;
                    return (ushort)( 1) ; 
                    }
                
                else 
                    {
                    __context__.SourceCodeLine = 295;
                    return (ushort)( 0) ; 
                    }
                
                } 
            
            __context__.SourceCodeLine = 298;
            while ( Functions.TestForTrue  ( ( Functions.BoolToInt (IT != 0))  ) ) 
                { 
                __context__.SourceCodeLine = 299;
                COUNT = (ushort) ( (COUNT + 1) ) ; 
                __context__.SourceCodeLine = 300;
                IT = (ushort) ( Functions.Find( "}," , ARRAY , (IT + 2) ) ) ; 
                __context__.SourceCodeLine = 298;
                } 
            
            __context__.SourceCodeLine = 303;
            COUNT = (ushort) ( (COUNT + 1) ) ; 
            __context__.SourceCodeLine = 305;
            return (ushort)( COUNT) ; 
            
            }
            
        private CrestronString GETARRAYITEM (  SplusExecutionContext __context__, CrestronString ARRAY , ushort INDEX ) 
            { 
            ushort IT = 0;
            
            ushort COUNT = 0;
            
            ushort START = 0;
            
            
            __context__.SourceCodeLine = 315;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( INDEX > GETARRAYCOUNT( __context__ , ARRAY ) ))  ) ) 
                {
                __context__.SourceCodeLine = 316;
                return ( "" ) ; 
                }
            
            __context__.SourceCodeLine = 318;
            IT = (ushort) ( Functions.Find( "}," , ARRAY ) ) ; 
            __context__.SourceCodeLine = 321;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (IT == 0))  ) ) 
                { 
                __context__.SourceCodeLine = 322;
                return ( Functions.Mid ( ARRAY ,  (int) ( 2 ) ,  (int) ( (Functions.Length( ARRAY ) - 2) ) ) ) ; 
                } 
            
            __context__.SourceCodeLine = 326;
            COUNT = (ushort) ( 1 ) ; 
            __context__.SourceCodeLine = 327;
            START = (ushort) ( 2 ) ; 
            __context__.SourceCodeLine = 329;
            while ( Functions.TestForTrue  ( ( Functions.BoolToInt ( COUNT < INDEX ))  ) ) 
                { 
                __context__.SourceCodeLine = 330;
                START = (ushort) ( (IT + 2) ) ; 
                __context__.SourceCodeLine = 331;
                COUNT = (ushort) ( (COUNT + 1) ) ; 
                __context__.SourceCodeLine = 332;
                IT = (ushort) ( Functions.Find( "}," , ARRAY , START ) ) ; 
                __context__.SourceCodeLine = 329;
                } 
            
            __context__.SourceCodeLine = 336;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (IT == 0))  ) ) 
                { 
                __context__.SourceCodeLine = 337;
                IT = (ushort) ( Functions.Find( "}" , ARRAY , START ) ) ; 
                } 
            
            __context__.SourceCodeLine = 340;
            return ( Functions.Mid ( ARRAY ,  (int) ( START ) ,  (int) ( ((IT - START) + 1) ) ) ) ; 
            
            }
            
        private CrestronString GETSOCKETERROR (  SplusExecutionContext __context__, ushort ERROR ) 
            { 
            
            __context__.SourceCodeLine = 345;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (ERROR == 0))  ) ) 
                {
                __context__.SourceCodeLine = 346;
                return ( "Not Connected" ) ; 
                }
            
            __context__.SourceCodeLine = 348;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (ERROR == 1))  ) ) 
                {
                __context__.SourceCodeLine = 349;
                return ( "Waiting for Connection" ) ; 
                }
            
            __context__.SourceCodeLine = 351;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (ERROR == 2))  ) ) 
                {
                __context__.SourceCodeLine = 352;
                return ( "Connected" ) ; 
                }
            
            __context__.SourceCodeLine = 354;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (ERROR == 3))  ) ) 
                {
                __context__.SourceCodeLine = 355;
                return ( "Connection Failed" ) ; 
                }
            
            __context__.SourceCodeLine = 357;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (ERROR == 4))  ) ) 
                {
                __context__.SourceCodeLine = 358;
                return ( "Connection Broken Remotely" ) ; 
                }
            
            __context__.SourceCodeLine = 360;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (ERROR == 5))  ) ) 
                {
                __context__.SourceCodeLine = 361;
                return ( "Connection Broken Locally" ) ; 
                }
            
            __context__.SourceCodeLine = 363;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (ERROR == 6))  ) ) 
                {
                __context__.SourceCodeLine = 364;
                return ( "Performing DNS Lookup" ) ; 
                }
            
            __context__.SourceCodeLine = 366;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (ERROR == 7))  ) ) 
                {
                __context__.SourceCodeLine = 367;
                return ( "DNS Lookup Failed" ) ; 
                }
            
            __context__.SourceCodeLine = 369;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (ERROR == 8))  ) ) 
                {
                __context__.SourceCodeLine = 370;
                return ( "DNS Name Resolved" ) ; 
                }
            
            __context__.SourceCodeLine = 372;
            return ( "Unknown error" ) ; 
            
            }
            
        private void API_SEND (  SplusExecutionContext __context__, CrestronString CMD ) 
            { 
            short RES = 0;
            
            CrestronString PACKET;
            PACKET  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 512, this );
            
            
            __context__.SourceCodeLine = 384;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (G_SOCKETSTATUS != 2))  ) ) 
                { 
                __context__.SourceCodeLine = 385;
                return ; 
                } 
            
            __context__.SourceCodeLine = 388;
            MakeString ( PACKET , "{0}{1}", CMD , Functions.Chr ( 10 ) ) ; 
            __context__.SourceCodeLine = 389;
            RES = (short) ( Functions.SocketSend( CLIENT , PACKET ) ) ; 
            __context__.SourceCodeLine = 391;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (RES == 0))  ) ) 
                { 
                __context__.SourceCodeLine = 392;
                Trace( "(API_Send) Sent[{0}]\r\n", CMD ) ; 
                } 
            
            else 
                { 
                __context__.SourceCodeLine = 394;
                Trace( "[ERROR] (API_Send) Unable to communicate with device!\r\n") ; 
                } 
            
            
            }
            
        private void API_LOGIN (  SplusExecutionContext __context__ ) 
            { 
            CrestronString EXTRA;
            EXTRA  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 256, this );
            
            
            __context__.SourceCodeLine = 402;
            MakeString ( EXTRA , "{0},{1}", MAKEKVPAIR (  __context__ , "username", USERNAME ) , MAKEKVPAIR (  __context__ , "password", PASSWORD ) ) ; 
            __context__.SourceCodeLine = 404;
            API_SEND (  __context__ , MAKECMD( __context__ , "login" , EXTRA )) ; 
            
            }
            
        private void API_GETOUTPUTSOURCE (  SplusExecutionContext __context__ ) 
            { 
            
            __context__.SourceCodeLine = 409;
            API_SEND (  __context__ , MAKECMD( __context__ , "get_outputsource1" , "" )) ; 
            
            }
            
        private void API_GETOUTPUTVOLUME (  SplusExecutionContext __context__ ) 
            { 
            
            __context__.SourceCodeLine = 414;
            API_SEND (  __context__ , MAKECMD( __context__ , "get_outputvol" , "" )) ; 
            
            }
            
        private void API_GETMUTEOUTPUT (  SplusExecutionContext __context__ ) 
            { 
            
            __context__.SourceCodeLine = 419;
            API_SEND (  __context__ , MAKECMD( __context__ , "get_muteoutput" , "" )) ; 
            
            }
            
        private void API_SETOUTPUTSOURCE (  SplusExecutionContext __context__, ushort OUTPUT , ushort INPUT ) 
            { 
            CrestronString VALUE;
            VALUE  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 256, this );
            
            
            __context__.SourceCodeLine = 426;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( (Functions.TestForTrue ( Functions.BoolToInt (OUTPUT == 99) ) || Functions.TestForTrue ( Functions.BoolToInt (INPUT == 99) )) ))  ) ) 
                {
                __context__.SourceCodeLine = 427;
                return ; 
                }
            
            __context__.SourceCodeLine = 429;
            Trace( "(API_SetOutputSource) Output[{0:d}] Input[{1:d}]\r\n", (short)OUTPUT, (short)INPUT) ; 
            __context__.SourceCodeLine = 431;
            MakeString ( VALUE , "[{{{0},{1}}}]", MAKEKVPAIRINT (  __context__ , "index", (ushort)( OUTPUT )) , MAKEKVPAIR (  __context__ , "value", Functions.ItoA( (int)( INPUT ) )) ) ; 
            __context__.SourceCodeLine = 434;
            G_SELECTED_INPUT = (ushort) ( 99 ) ; 
            __context__.SourceCodeLine = 435;
            G_SELECTED_OUTPUT = (ushort) ( 99 ) ; 
            __context__.SourceCodeLine = 437;
            API_SEND (  __context__ , MAKECMD( __context__ , "set_outputsource1" , MAKEKVPAIRNOQUOTES( __context__ , "value" , VALUE ) )) ; 
            
            }
            
        private void API_SETOUTPUTVOLUME (  SplusExecutionContext __context__, ushort OUTPUT , short LEVEL ) 
            { 
            CrestronString VALUE;
            VALUE  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 256, this );
            
            CrestronString VOLUME;
            VOLUME  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 16, this );
            
            
            __context__.SourceCodeLine = 445;
            MakeString ( VOLUME , "{0:d}", (short)LEVEL) ; 
            __context__.SourceCodeLine = 447;
            MakeString ( VALUE , "[{{{0},{1}}}]", MAKEKVPAIRINT (  __context__ , "index", (ushort)( OUTPUT )) , MAKEKVPAIR (  __context__ , "value", VOLUME) ) ; 
            __context__.SourceCodeLine = 449;
            API_SEND (  __context__ , MAKECMD( __context__ , "set_outputvol" , MAKEKVPAIRNOQUOTES( __context__ , "value" , VALUE ) )) ; 
            
            }
            
        private void API_OUTPUTVOLUMEUP (  SplusExecutionContext __context__, ushort OUTPUT ) 
            { 
            CrestronString VALUE;
            VALUE  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 256, this );
            
            
            __context__.SourceCodeLine = 455;
            MakeString ( VALUE , "[{{{0},{1}}}]", MAKEKVPAIRINT (  __context__ , "index", (ushort)( OUTPUT )) , MAKEKVPAIR (  __context__ , "value", "vol_up") ) ; 
            __context__.SourceCodeLine = 457;
            API_SEND (  __context__ , MAKECMD( __context__ , "set_outputvolsign" , MAKEKVPAIRNOQUOTES( __context__ , "value" , VALUE ) )) ; 
            
            }
            
        private void API_OUTPUTVOLUMEDOWN (  SplusExecutionContext __context__, ushort OUTPUT ) 
            { 
            CrestronString VALUE;
            VALUE  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 256, this );
            
            
            __context__.SourceCodeLine = 463;
            MakeString ( VALUE , "[{{{0},{1}}}]", MAKEKVPAIRINT (  __context__ , "index", (ushort)( OUTPUT )) , MAKEKVPAIR (  __context__ , "value", "vol_down") ) ; 
            __context__.SourceCodeLine = 465;
            API_SEND (  __context__ , MAKECMD( __context__ , "set_outputvolsign" , MAKEKVPAIRNOQUOTES( __context__ , "value" , VALUE ) )) ; 
            
            }
            
        private void API_TOGGLEOUTPUTMUTE (  SplusExecutionContext __context__, ushort OUTPUT ) 
            { 
            CrestronString VALUE;
            VALUE  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 256, this );
            
            CrestronString MUTE;
            MUTE  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 2, this );
            
            
            __context__.SourceCodeLine = 476;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (G_OUTPUT_MUTE[ OUTPUT ] == 0))  ) ) 
                { 
                __context__.SourceCodeLine = 477;
                MUTE  .UpdateValue ( "1"  ) ; 
                __context__.SourceCodeLine = 478;
                G_OUTPUT_MUTE [ OUTPUT] = (ushort) ( 1 ) ; 
                } 
            
            else 
                { 
                __context__.SourceCodeLine = 480;
                MUTE  .UpdateValue ( "0"  ) ; 
                __context__.SourceCodeLine = 481;
                G_OUTPUT_MUTE [ OUTPUT] = (ushort) ( 0 ) ; 
                } 
            
            __context__.SourceCodeLine = 484;
            MakeString ( VALUE , "[{{{0},{1}}}]", MAKEKVPAIRINT (  __context__ , "index", (ushort)( OUTPUT )) , MAKEKVPAIR (  __context__ , "value", MUTE) ) ; 
            __context__.SourceCodeLine = 486;
            API_SEND (  __context__ , MAKECMD( __context__ , "set_muteoutput" , MAKEKVPAIRNOQUOTES( __context__ , "value" , VALUE ) )) ; 
            
            }
            
        private void API_INIT (  SplusExecutionContext __context__ ) 
            { 
            
            __context__.SourceCodeLine = 491;
            Trace( "(API_Init)\r\n") ; 
            __context__.SourceCodeLine = 493;
            API_GETOUTPUTSOURCE (  __context__  ) ; 
            __context__.SourceCodeLine = 494;
            API_GETOUTPUTVOLUME (  __context__  ) ; 
            __context__.SourceCodeLine = 495;
            API_GETMUTEOUTPUT (  __context__  ) ; 
            
            }
            
        private void API_PARSE_LOGIN (  SplusExecutionContext __context__, CrestronString DATA ) 
            { 
            ushort STATUS = 0;
            
            
            __context__.SourceCodeLine = 504;
            STATUS = (ushort) ( GETINT( __context__ , DATA , "status" ) ) ; 
            __context__.SourceCodeLine = 506;
            Trace( "(API_Parse_Login) Status[{0:d}]\r\n", (short)STATUS) ; 
            __context__.SourceCodeLine = 508;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (STATUS == 200))  ) ) 
                { 
                __context__.SourceCodeLine = 509;
                Trace( "Successfully logged in!\r\n") ; 
                __context__.SourceCodeLine = 510;
                API_INIT (  __context__  ) ; 
                } 
            
            else 
                { 
                __context__.SourceCodeLine = 512;
                Trace( "Failed to login! Please double check username and password!\r\n") ; 
                } 
            
            
            }
            
        private void API_PARSE_SOURCES (  SplusExecutionContext __context__, CrestronString DATA ) 
            { 
            ushort COUNT = 0;
            
            ushort X = 0;
            
            ushort INDEX = 0;
            
            ushort V = 0;
            
            CrestronString VALUE;
            VALUE  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1024, this );
            
            CrestronString ITEM;
            ITEM  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 256, this );
            
            
            __context__.SourceCodeLine = 527;
            VALUE  .UpdateValue ( GETOBJECT (  __context__ , DATA, "value")  ) ; 
            __context__.SourceCodeLine = 528;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( Functions.Length( VALUE ) < 1 ))  ) ) 
                {
                __context__.SourceCodeLine = 529;
                return ; 
                }
            
            __context__.SourceCodeLine = 531;
            COUNT = (ushort) ( GETARRAYCOUNT( __context__ , VALUE ) ) ; 
            __context__.SourceCodeLine = 532;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( COUNT < 1 ))  ) ) 
                {
                __context__.SourceCodeLine = 533;
                return ; 
                }
            
            __context__.SourceCodeLine = 535;
            ushort __FN_FORSTART_VAL__1 = (ushort) ( 1 ) ;
            ushort __FN_FOREND_VAL__1 = (ushort)COUNT; 
            int __FN_FORSTEP_VAL__1 = (int)1; 
            for ( X  = __FN_FORSTART_VAL__1; (__FN_FORSTEP_VAL__1 > 0)  ? ( (X  >= __FN_FORSTART_VAL__1) && (X  <= __FN_FOREND_VAL__1) ) : ( (X  <= __FN_FORSTART_VAL__1) && (X  >= __FN_FOREND_VAL__1) ) ; X  += (ushort)__FN_FORSTEP_VAL__1) 
                { 
                __context__.SourceCodeLine = 536;
                ITEM  .UpdateValue ( GETARRAYITEM (  __context__ , VALUE, (ushort)( X ))  ) ; 
                __context__.SourceCodeLine = 537;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( Functions.Length( ITEM ) < 1 ))  ) ) 
                    {
                    __context__.SourceCodeLine = 538;
                    return ; 
                    }
                
                __context__.SourceCodeLine = 540;
                INDEX = (ushort) ( (GETINT( __context__ , ITEM , "index" ) + 1) ) ; 
                __context__.SourceCodeLine = 541;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( INDEX < 1 ))  ) ) 
                    {
                    __context__.SourceCodeLine = 542;
                    return ; 
                    }
                
                __context__.SourceCodeLine = 544;
                V = (ushort) ( Functions.Atoi( GETVALUE( __context__ , ITEM , "value" ) ) ) ; 
                __context__.SourceCodeLine = 545;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( (Functions.TestForTrue ( Functions.BoolToInt ( V < 1 ) ) || Functions.TestForTrue ( Functions.BoolToInt ( V > 16 ) )) ))  ) ) 
                    {
                    __context__.SourceCodeLine = 546;
                    return ; 
                    }
                
                __context__.SourceCodeLine = 548;
                OUTPUT_SOURCE [ INDEX]  .Value = (ushort) ( V ) ; 
                __context__.SourceCodeLine = 535;
                } 
            
            
            }
            
        private void API_PARSE_VOLUME (  SplusExecutionContext __context__, CrestronString DATA ) 
            { 
            ushort COUNT = 0;
            
            ushort X = 0;
            
            ushort INDEX = 0;
            
            short V = 0;
            
            CrestronString VALUE;
            VALUE  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1024, this );
            
            CrestronString ITEM;
            ITEM  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 256, this );
            
            
            __context__.SourceCodeLine = 563;
            VALUE  .UpdateValue ( GETOBJECT (  __context__ , DATA, "value")  ) ; 
            __context__.SourceCodeLine = 564;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( Functions.Length( VALUE ) < 1 ))  ) ) 
                {
                __context__.SourceCodeLine = 565;
                return ; 
                }
            
            __context__.SourceCodeLine = 567;
            COUNT = (ushort) ( GETARRAYCOUNT( __context__ , VALUE ) ) ; 
            __context__.SourceCodeLine = 568;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( COUNT < 1 ))  ) ) 
                {
                __context__.SourceCodeLine = 569;
                return ; 
                }
            
            __context__.SourceCodeLine = 571;
            ushort __FN_FORSTART_VAL__1 = (ushort) ( 1 ) ;
            ushort __FN_FOREND_VAL__1 = (ushort)COUNT; 
            int __FN_FORSTEP_VAL__1 = (int)1; 
            for ( X  = __FN_FORSTART_VAL__1; (__FN_FORSTEP_VAL__1 > 0)  ? ( (X  >= __FN_FORSTART_VAL__1) && (X  <= __FN_FOREND_VAL__1) ) : ( (X  <= __FN_FORSTART_VAL__1) && (X  >= __FN_FOREND_VAL__1) ) ; X  += (ushort)__FN_FORSTEP_VAL__1) 
                { 
                __context__.SourceCodeLine = 572;
                ITEM  .UpdateValue ( GETARRAYITEM (  __context__ , VALUE, (ushort)( X ))  ) ; 
                __context__.SourceCodeLine = 573;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( Functions.Length( ITEM ) < 1 ))  ) ) 
                    {
                    __context__.SourceCodeLine = 574;
                    return ; 
                    }
                
                __context__.SourceCodeLine = 576;
                INDEX = (ushort) ( (GETINT( __context__ , ITEM , "index" ) + 1) ) ; 
                __context__.SourceCodeLine = 577;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( INDEX < 1 ))  ) ) 
                    {
                    __context__.SourceCodeLine = 578;
                    return ; 
                    }
                
                __context__.SourceCodeLine = 580;
                V = (short) ( Functions.Atoi( GETVALUE( __context__ , ITEM , "value" ) ) ) ; 
                __context__.SourceCodeLine = 582;
                OUTPUT_VOLUME [ INDEX]  .Value = (ushort) ( V ) ; 
                __context__.SourceCodeLine = 571;
                } 
            
            
            }
            
        private void API_PARSE_MUTE (  SplusExecutionContext __context__, CrestronString DATA ) 
            { 
            ushort COUNT = 0;
            
            ushort X = 0;
            
            ushort INDEX = 0;
            
            short V = 0;
            
            CrestronString VALUE;
            VALUE  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1024, this );
            
            CrestronString ITEM;
            ITEM  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 256, this );
            
            
            __context__.SourceCodeLine = 597;
            VALUE  .UpdateValue ( GETOBJECT (  __context__ , DATA, "value")  ) ; 
            __context__.SourceCodeLine = 598;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( Functions.Length( VALUE ) < 1 ))  ) ) 
                {
                __context__.SourceCodeLine = 599;
                return ; 
                }
            
            __context__.SourceCodeLine = 601;
            COUNT = (ushort) ( GETARRAYCOUNT( __context__ , VALUE ) ) ; 
            __context__.SourceCodeLine = 602;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( COUNT < 1 ))  ) ) 
                {
                __context__.SourceCodeLine = 603;
                return ; 
                }
            
            __context__.SourceCodeLine = 605;
            ushort __FN_FORSTART_VAL__1 = (ushort) ( 1 ) ;
            ushort __FN_FOREND_VAL__1 = (ushort)COUNT; 
            int __FN_FORSTEP_VAL__1 = (int)1; 
            for ( X  = __FN_FORSTART_VAL__1; (__FN_FORSTEP_VAL__1 > 0)  ? ( (X  >= __FN_FORSTART_VAL__1) && (X  <= __FN_FOREND_VAL__1) ) : ( (X  <= __FN_FORSTART_VAL__1) && (X  >= __FN_FOREND_VAL__1) ) ; X  += (ushort)__FN_FORSTEP_VAL__1) 
                { 
                __context__.SourceCodeLine = 606;
                ITEM  .UpdateValue ( GETARRAYITEM (  __context__ , VALUE, (ushort)( X ))  ) ; 
                __context__.SourceCodeLine = 607;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( Functions.Length( ITEM ) < 1 ))  ) ) 
                    {
                    __context__.SourceCodeLine = 608;
                    return ; 
                    }
                
                __context__.SourceCodeLine = 610;
                INDEX = (ushort) ( GETINT( __context__ , ITEM , "index" ) ) ; 
                __context__.SourceCodeLine = 611;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( INDEX > 16 ))  ) ) 
                    {
                    __context__.SourceCodeLine = 612;
                    return ; 
                    }
                
                __context__.SourceCodeLine = 614;
                V = (short) ( Functions.Atoi( GETVALUE( __context__ , ITEM , "value" ) ) ) ; 
                __context__.SourceCodeLine = 615;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( (Functions.TestForTrue ( Functions.BoolToInt (V != 0) ) && Functions.TestForTrue ( Functions.BoolToInt (V != 1) )) ))  ) ) 
                    {
                    __context__.SourceCodeLine = 616;
                    return ; 
                    }
                
                __context__.SourceCodeLine = 618;
                G_OUTPUT_MUTE [ INDEX] = (ushort) ( V ) ; 
                __context__.SourceCodeLine = 605;
                } 
            
            
            }
            
        private void API_PARSERECEIVED (  SplusExecutionContext __context__, CrestronString DATA ) 
            { 
            CrestronString TYPE;
            TYPE  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 32, this );
            
            ushort STATUS = 0;
            
            
            __context__.SourceCodeLine = 627;
            TYPE  .UpdateValue ( GETVALUE (  __context__ , DATA, "type")  ) ; 
            __context__.SourceCodeLine = 628;
            STATUS = (ushort) ( GETINT( __context__ , DATA , "status" ) ) ; 
            __context__.SourceCodeLine = 632;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (STATUS == 402))  ) ) 
                { 
                __context__.SourceCodeLine = 633;
                Trace( "(API_ParseReceived) Unauthorized, attempting to login.") ; 
                __context__.SourceCodeLine = 634;
                API_LOGIN (  __context__  ) ; 
                __context__.SourceCodeLine = 635;
                return ; 
                } 
            
            __context__.SourceCodeLine = 638;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (TYPE == "login"))  ) ) 
                { 
                __context__.SourceCodeLine = 639;
                API_PARSE_LOGIN (  __context__ , DATA) ; 
                } 
            
            else 
                {
                __context__.SourceCodeLine = 640;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt (TYPE == "get_outputsource1"))  ) ) 
                    { 
                    __context__.SourceCodeLine = 641;
                    API_PARSE_SOURCES (  __context__ , DATA) ; 
                    } 
                
                else 
                    {
                    __context__.SourceCodeLine = 642;
                    if ( Functions.TestForTrue  ( ( Functions.BoolToInt (TYPE == "get_outputvol"))  ) ) 
                        { 
                        __context__.SourceCodeLine = 643;
                        API_PARSE_VOLUME (  __context__ , DATA) ; 
                        } 
                    
                    else 
                        {
                        __context__.SourceCodeLine = 644;
                        if ( Functions.TestForTrue  ( ( Functions.BoolToInt (TYPE == "get_muteoutput"))  ) ) 
                            { 
                            __context__.SourceCodeLine = 645;
                            API_PARSE_MUTE (  __context__ , DATA) ; 
                            } 
                        
                        else 
                            {
                            __context__.SourceCodeLine = 646;
                            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (TYPE == "set_muteoutput"))  ) ) 
                                { 
                                } 
                            
                            else 
                                {
                                __context__.SourceCodeLine = 648;
                                if ( Functions.TestForTrue  ( ( Functions.BoolToInt (TYPE == "set_outputsource1"))  ) ) 
                                    { 
                                    } 
                                
                                else 
                                    {
                                    __context__.SourceCodeLine = 650;
                                    if ( Functions.TestForTrue  ( ( Functions.BoolToInt (TYPE == "set_outputvol"))  ) ) 
                                        { 
                                        } 
                                    
                                    else 
                                        { 
                                        __context__.SourceCodeLine = 653;
                                        Trace( "(API_ParseReceived) Unknown Type!\r\n") ; 
                                        } 
                                    
                                    }
                                
                                }
                            
                            }
                        
                        }
                    
                    }
                
                }
            
            
            }
            
        object OUTPUT_VOLUME_UP_OnPush_0 ( Object __EventInfo__ )
        
            { 
            Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
            try
            {
                SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
                ushort I = 0;
                
                
                __context__.SourceCodeLine = 665;
                I = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
                __context__.SourceCodeLine = 667;
                Trace( "(OUTPUT_VOLUME_UP) [{0:d}]\r\n", (short)I) ; 
                __context__.SourceCodeLine = 669;
                API_OUTPUTVOLUMEDOWN (  __context__ , (ushort)( (I - 1) )) ; 
                
                
            }
            catch(Exception e) { ObjectCatchHandler(e); }
            finally { ObjectFinallyHandler( __SignalEventArg__ ); }
            return this;
            
        }
        
    object OUTPUT_VOLUME_UP_OnRelease_1 ( Object __EventInfo__ )
    
        { 
        Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
        try
        {
            SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
            
            __context__.SourceCodeLine = 674;
            API_GETOUTPUTVOLUME (  __context__  ) ; 
            
            
        }
        catch(Exception e) { ObjectCatchHandler(e); }
        finally { ObjectFinallyHandler( __SignalEventArg__ ); }
        return this;
        
    }
    
object OUTPUT_VOLUME_DOWN_OnPush_2 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort I = 0;
        
        
        __context__.SourceCodeLine = 680;
        I = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 682;
        Trace( "(OUTPUT_VOLUME_DOWN) [{0:d}]\r\n", (short)I) ; 
        __context__.SourceCodeLine = 684;
        API_OUTPUTVOLUMEUP (  __context__ , (ushort)( (I - 1) )) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object OUTPUT_VOLUME_DOWN_OnRelease_3 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 689;
        API_GETOUTPUTVOLUME (  __context__  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object MUTE_OUTPUT_OnPush_4 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort I = 0;
        
        
        __context__.SourceCodeLine = 696;
        I = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 698;
        Trace( "(MUTE_OUTPUT) [{0:d}]\r\n", (short)I) ; 
        __context__.SourceCodeLine = 700;
        API_TOGGLEOUTPUTMUTE (  __context__ , (ushort)( (I - 1) )) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SELECT_OUTPUT_OnPush_5 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort I = 0;
        
        
        __context__.SourceCodeLine = 706;
        I = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 708;
        Trace( "(SELECT_OUTPUT) [{0:d}]\r\n", (short)I) ; 
        __context__.SourceCodeLine = 710;
        G_SELECTED_OUTPUT = (ushort) ( (I - 1) ) ; 
        __context__.SourceCodeLine = 712;
        API_SETOUTPUTSOURCE (  __context__ , (ushort)( G_SELECTED_OUTPUT ), (ushort)( G_SELECTED_INPUT )) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SELECT_INPUT_OnPush_6 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort I = 0;
        
        
        __context__.SourceCodeLine = 718;
        I = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 720;
        Trace( "(SELECT_INPUT) [{0:d}]\r\n", (short)I) ; 
        __context__.SourceCodeLine = 722;
        G_SELECTED_INPUT = (ushort) ( (I - 1) ) ; 
        __context__.SourceCodeLine = 724;
        API_SETOUTPUTSOURCE (  __context__ , (ushort)( G_SELECTED_OUTPUT ), (ushort)( G_SELECTED_INPUT )) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SET_OUTPUT_VOLUME_OnChange_7 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        short V = 0;
        
        ushort I = 0;
        
        
        __context__.SourceCodeLine = 731;
        I = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 733;
        Trace( "(SET_OUTPUT_VOLUME) [{0:d}] - {1:d}\r\n", (short)I, (short)SET_OUTPUT_VOLUME[ I ] .UshortValue) ; 
        __context__.SourceCodeLine = 735;
        V = (short) ( SET_OUTPUT_VOLUME[ I ] .ShortValue ) ; 
        __context__.SourceCodeLine = 737;
        API_SETOUTPUTVOLUME (  __context__ , (ushort)( (I - 1) ), (short)( V )) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object CLIENT_OnSocketConnect_8 ( Object __Info__ )

    { 
    SocketEventInfo __SocketInfo__ = (SocketEventInfo)__Info__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SocketInfo__);
        
        __context__.SourceCodeLine = 742;
        Trace( "(SOCKETCONNECT)\r\n") ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SocketInfo__ ); }
    return this;
    
}

object CLIENT_OnSocketDisconnect_9 ( Object __Info__ )

    { 
    SocketEventInfo __SocketInfo__ = (SocketEventInfo)__Info__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SocketInfo__);
        
        __context__.SourceCodeLine = 747;
        Trace( "(SOCKETDISCONNECT)\r\n") ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SocketInfo__ ); }
    return this;
    
}

object CLIENT_OnSocketReceive_10 ( Object __Info__ )

    { 
    SocketEventInfo __SocketInfo__ = (SocketEventInfo)__Info__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SocketInfo__);
        CrestronString RECEIVEDDATA;
        RECEIVEDDATA  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 10240, this );
        
        
        __context__.SourceCodeLine = 754;
        RECEIVEDDATA  .UpdateValue ( CLIENT .  SocketRxBuf  ) ; 
        __context__.SourceCodeLine = 756;
        Functions.ClearBuffer ( CLIENT .  SocketRxBuf ) ; 
        __context__.SourceCodeLine = 758;
        Trace( "(SOCKETRECEIVE): Data Received: {0}\r\n", RECEIVEDDATA ) ; 
        __context__.SourceCodeLine = 760;
        API_PARSERECEIVED (  __context__ , RECEIVEDDATA) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SocketInfo__ ); }
    return this;
    
}

object CLIENT_OnSocketStatus_11 ( Object __Info__ )

    { 
    SocketEventInfo __SocketInfo__ = (SocketEventInfo)__Info__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SocketInfo__);
        ushort STATUS = 0;
        
        
        __context__.SourceCodeLine = 767;
        STATUS = (ushort) ( __SocketInfo__.SocketStatus ) ; 
        __context__.SourceCodeLine = 769;
        Trace( "(SOCKETSTATUS): Status: {0}\r\n", GETSOCKETERROR (  __context__ , (ushort)( STATUS )) ) ; 
        __context__.SourceCodeLine = 771;
        if ( Functions.TestForTrue  ( ( Functions.BoolToInt (STATUS != G_SOCKETSTATUS))  ) ) 
            { 
            __context__.SourceCodeLine = 772;
            G_SOCKETSTATUS = (short) ( STATUS ) ; 
            __context__.SourceCodeLine = 774;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (G_SOCKETSTATUS == 2))  ) ) 
                { 
                __context__.SourceCodeLine = 775;
                API_LOGIN (  __context__  ) ; 
                } 
            
            } 
        
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SocketInfo__ ); }
    return this;
    
}

public override object FunctionMain (  object __obj__ ) 
    { 
    try
    {
        SplusExecutionContext __context__ = SplusFunctionMainStartCode();
        
        __context__.SourceCodeLine = 791;
        G_SELECTED_OUTPUT = (ushort) ( 99 ) ; 
        __context__.SourceCodeLine = 792;
        G_SELECTED_INPUT = (ushort) ( 99 ) ; 
        __context__.SourceCodeLine = 794;
        WaitForInitializationComplete ( ) ; 
        __context__.SourceCodeLine = 801;
        G_CONNECTIONSTATUS = (short) ( Functions.SocketConnectClient( CLIENT , IP_ADDRESS  , (ushort)( 8080 ) , (ushort)( 1 ) ) ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler(); }
    return __obj__;
    }
    

public override void LogosSplusInitialize()
{
    SocketInfo __socketinfo__ = new SocketInfo( 1, this );
    InitialParametersClass.ResolveHostName = __socketinfo__.ResolveHostName;
    _SplusNVRAM = new SplusNVRAM( this );
    G_OUTPUT_MUTE  = new ushort[ 17 ];
    CLIENT  = new SplusTcpClient ( 10240, this );
    
    SELECT_OUTPUT = new InOutArray<DigitalInput>( 16, this );
    for( uint i = 0; i < 16; i++ )
    {
        SELECT_OUTPUT[i+1] = new Crestron.Logos.SplusObjects.DigitalInput( SELECT_OUTPUT__DigitalInput__ + i, SELECT_OUTPUT__DigitalInput__, this );
        m_DigitalInputList.Add( SELECT_OUTPUT__DigitalInput__ + i, SELECT_OUTPUT[i+1] );
    }
    
    SELECT_INPUT = new InOutArray<DigitalInput>( 16, this );
    for( uint i = 0; i < 16; i++ )
    {
        SELECT_INPUT[i+1] = new Crestron.Logos.SplusObjects.DigitalInput( SELECT_INPUT__DigitalInput__ + i, SELECT_INPUT__DigitalInput__, this );
        m_DigitalInputList.Add( SELECT_INPUT__DigitalInput__ + i, SELECT_INPUT[i+1] );
    }
    
    OUTPUT_VOLUME_UP = new InOutArray<DigitalInput>( 16, this );
    for( uint i = 0; i < 16; i++ )
    {
        OUTPUT_VOLUME_UP[i+1] = new Crestron.Logos.SplusObjects.DigitalInput( OUTPUT_VOLUME_UP__DigitalInput__ + i, OUTPUT_VOLUME_UP__DigitalInput__, this );
        m_DigitalInputList.Add( OUTPUT_VOLUME_UP__DigitalInput__ + i, OUTPUT_VOLUME_UP[i+1] );
    }
    
    OUTPUT_VOLUME_DOWN = new InOutArray<DigitalInput>( 16, this );
    for( uint i = 0; i < 16; i++ )
    {
        OUTPUT_VOLUME_DOWN[i+1] = new Crestron.Logos.SplusObjects.DigitalInput( OUTPUT_VOLUME_DOWN__DigitalInput__ + i, OUTPUT_VOLUME_DOWN__DigitalInput__, this );
        m_DigitalInputList.Add( OUTPUT_VOLUME_DOWN__DigitalInput__ + i, OUTPUT_VOLUME_DOWN[i+1] );
    }
    
    MUTE_OUTPUT = new InOutArray<DigitalInput>( 16, this );
    for( uint i = 0; i < 16; i++ )
    {
        MUTE_OUTPUT[i+1] = new Crestron.Logos.SplusObjects.DigitalInput( MUTE_OUTPUT__DigitalInput__ + i, MUTE_OUTPUT__DigitalInput__, this );
        m_DigitalInputList.Add( MUTE_OUTPUT__DigitalInput__ + i, MUTE_OUTPUT[i+1] );
    }
    
    SET_OUTPUT_VOLUME = new InOutArray<AnalogInput>( 16, this );
    for( uint i = 0; i < 16; i++ )
    {
        SET_OUTPUT_VOLUME[i+1] = new Crestron.Logos.SplusObjects.AnalogInput( SET_OUTPUT_VOLUME__AnalogSerialInput__ + i, SET_OUTPUT_VOLUME__AnalogSerialInput__, this );
        m_AnalogInputList.Add( SET_OUTPUT_VOLUME__AnalogSerialInput__ + i, SET_OUTPUT_VOLUME[i+1] );
    }
    
    OUTPUT_SOURCE = new InOutArray<AnalogOutput>( 16, this );
    for( uint i = 0; i < 16; i++ )
    {
        OUTPUT_SOURCE[i+1] = new Crestron.Logos.SplusObjects.AnalogOutput( OUTPUT_SOURCE__AnalogSerialOutput__ + i, this );
        m_AnalogOutputList.Add( OUTPUT_SOURCE__AnalogSerialOutput__ + i, OUTPUT_SOURCE[i+1] );
    }
    
    OUTPUT_VOLUME = new InOutArray<AnalogOutput>( 16, this );
    for( uint i = 0; i < 16; i++ )
    {
        OUTPUT_VOLUME[i+1] = new Crestron.Logos.SplusObjects.AnalogOutput( OUTPUT_VOLUME__AnalogSerialOutput__ + i, this );
        m_AnalogOutputList.Add( OUTPUT_VOLUME__AnalogSerialOutput__ + i, OUTPUT_VOLUME[i+1] );
    }
    
    IP_ADDRESS = new StringParameter( IP_ADDRESS__Parameter__, this );
    m_ParameterList.Add( IP_ADDRESS__Parameter__, IP_ADDRESS );
    
    USERNAME = new StringParameter( USERNAME__Parameter__, this );
    m_ParameterList.Add( USERNAME__Parameter__, USERNAME );
    
    PASSWORD = new StringParameter( PASSWORD__Parameter__, this );
    m_ParameterList.Add( PASSWORD__Parameter__, PASSWORD );
    
    
    for( uint i = 0; i < 16; i++ )
        OUTPUT_VOLUME_UP[i+1].OnDigitalPush.Add( new InputChangeHandlerWrapper( OUTPUT_VOLUME_UP_OnPush_0, false ) );
        
    for( uint i = 0; i < 16; i++ )
        OUTPUT_VOLUME_UP[i+1].OnDigitalRelease.Add( new InputChangeHandlerWrapper( OUTPUT_VOLUME_UP_OnRelease_1, false ) );
        
    for( uint i = 0; i < 16; i++ )
        OUTPUT_VOLUME_DOWN[i+1].OnDigitalPush.Add( new InputChangeHandlerWrapper( OUTPUT_VOLUME_DOWN_OnPush_2, false ) );
        
    for( uint i = 0; i < 16; i++ )
        OUTPUT_VOLUME_DOWN[i+1].OnDigitalRelease.Add( new InputChangeHandlerWrapper( OUTPUT_VOLUME_DOWN_OnRelease_3, false ) );
        
    for( uint i = 0; i < 16; i++ )
        MUTE_OUTPUT[i+1].OnDigitalPush.Add( new InputChangeHandlerWrapper( MUTE_OUTPUT_OnPush_4, false ) );
        
    for( uint i = 0; i < 16; i++ )
        SELECT_OUTPUT[i+1].OnDigitalPush.Add( new InputChangeHandlerWrapper( SELECT_OUTPUT_OnPush_5, false ) );
        
    for( uint i = 0; i < 16; i++ )
        SELECT_INPUT[i+1].OnDigitalPush.Add( new InputChangeHandlerWrapper( SELECT_INPUT_OnPush_6, false ) );
        
    for( uint i = 0; i < 16; i++ )
        SET_OUTPUT_VOLUME[i+1].OnAnalogChange.Add( new InputChangeHandlerWrapper( SET_OUTPUT_VOLUME_OnChange_7, false ) );
        
    CLIENT.OnSocketConnect.Add( new SocketHandlerWrapper( CLIENT_OnSocketConnect_8, false ) );
    CLIENT.OnSocketDisconnect.Add( new SocketHandlerWrapper( CLIENT_OnSocketDisconnect_9, false ) );
    CLIENT.OnSocketReceive.Add( new SocketHandlerWrapper( CLIENT_OnSocketReceive_10, false ) );
    CLIENT.OnSocketStatus.Add( new SocketHandlerWrapper( CLIENT_OnSocketStatus_11, false ) );
    
    _SplusNVRAM.PopulateCustomAttributeList( true );
    
    NVRAM = _SplusNVRAM;
    
}

public override void LogosSimplSharpInitialize()
{
    
    
}

public UserModuleClass_EPISODE_EA_RSP_V1_1 ( string InstanceName, string ReferenceID, Crestron.Logos.SplusObjects.CrestronStringEncoding nEncodingType ) : base( InstanceName, ReferenceID, nEncodingType ) {}




const uint SELECT_OUTPUT__DigitalInput__ = 0;
const uint SELECT_INPUT__DigitalInput__ = 16;
const uint OUTPUT_VOLUME_UP__DigitalInput__ = 32;
const uint OUTPUT_VOLUME_DOWN__DigitalInput__ = 48;
const uint MUTE_OUTPUT__DigitalInput__ = 64;
const uint SET_OUTPUT_VOLUME__AnalogSerialInput__ = 0;
const uint OUTPUT_SOURCE__AnalogSerialOutput__ = 0;
const uint OUTPUT_VOLUME__AnalogSerialOutput__ = 16;
const uint IP_ADDRESS__Parameter__ = 10;
const uint USERNAME__Parameter__ = 11;
const uint PASSWORD__Parameter__ = 12;

[SplusStructAttribute(-1, true, false)]
public class SplusNVRAM : SplusStructureBase
{

    public SplusNVRAM( SplusObject __caller__ ) : base( __caller__ ) {}
    
    
}

SplusNVRAM _SplusNVRAM = null;

public class __CEvent__ : CEvent
{
    public __CEvent__() {}
    public void Close() { base.Close(); }
    public int Reset() { return base.Reset() ? 1 : 0; }
    public int Set() { return base.Set() ? 1 : 0; }
    public int Wait( int timeOutInMs ) { return base.Wait( timeOutInMs ) ? 1 : 0; }
}
public class __CMutex__ : CMutex
{
    public __CMutex__() {}
    public void Close() { base.Close(); }
    public void ReleaseMutex() { base.ReleaseMutex(); }
    public int WaitForMutex() { return base.WaitForMutex() ? 1 : 0; }
}
 public int IsNull( object obj ){ return (obj == null) ? 1 : 0; }
}


}
