#ifndef __S2_EPISODE_EA_RSP_V1_1_H__
#define __S2_EPISODE_EA_RSP_V1_1_H__




/*
* Constructor and Destructor
*/

/*
* DIGITAL_INPUT
*/

#define __S2_Episode_EA_RSP_v1_1_SELECT_OUTPUT_DIG_INPUT 0
#define __S2_Episode_EA_RSP_v1_1_SELECT_OUTPUT_ARRAY_LENGTH 16
#define __S2_Episode_EA_RSP_v1_1_SELECT_INPUT_DIG_INPUT 16
#define __S2_Episode_EA_RSP_v1_1_SELECT_INPUT_ARRAY_LENGTH 16
#define __S2_Episode_EA_RSP_v1_1_OUTPUT_VOLUME_UP_DIG_INPUT 32
#define __S2_Episode_EA_RSP_v1_1_OUTPUT_VOLUME_UP_ARRAY_LENGTH 16
#define __S2_Episode_EA_RSP_v1_1_OUTPUT_VOLUME_DOWN_DIG_INPUT 48
#define __S2_Episode_EA_RSP_v1_1_OUTPUT_VOLUME_DOWN_ARRAY_LENGTH 16
#define __S2_Episode_EA_RSP_v1_1_MUTE_OUTPUT_DIG_INPUT 64
#define __S2_Episode_EA_RSP_v1_1_MUTE_OUTPUT_ARRAY_LENGTH 16

/*
* ANALOG_INPUT
*/



#define __S2_Episode_EA_RSP_v1_1_SET_OUTPUT_VOLUME_ANALOG_INPUT 0
#define __S2_Episode_EA_RSP_v1_1_SET_OUTPUT_VOLUME_ARRAY_LENGTH 16

/*
* DIGITAL_OUTPUT
*/


/*
* ANALOG_OUTPUT
*/


#define __S2_Episode_EA_RSP_v1_1_OUTPUT_SOURCE_ANALOG_OUTPUT 0
#define __S2_Episode_EA_RSP_v1_1_OUTPUT_SOURCE_ARRAY_LENGTH 16
#define __S2_Episode_EA_RSP_v1_1_OUTPUT_VOLUME_ANALOG_OUTPUT 16
#define __S2_Episode_EA_RSP_v1_1_OUTPUT_VOLUME_ARRAY_LENGTH 16

/*
* Direct Socket Variables
*/

#define __S2_Episode_EA_RSP_v1_1_CLIENT_SOCKET 17
#define __S2_Episode_EA_RSP_v1_1_CLIENT_STRING_MAX_LEN 10240
START_SOCKET_DEFINITION( S2_Episode_EA_RSP_v1_1, __CLIENT )
{
   int SocketStatus;
   enum ESplusSocketType eSocketType;
   int SocketID;
   void *SocketPtr;
CREATE_SOCKET_STRING( S2_Episode_EA_RSP_v1_1, SocketRxBuf, __S2_Episode_EA_RSP_v1_1_CLIENT_STRING_MAX_LEN );
};



/*
* INTEGER_PARAMETER
*/
/*
* SIGNED_INTEGER_PARAMETER
*/
/*
* LONG_INTEGER_PARAMETER
*/
/*
* SIGNED_LONG_INTEGER_PARAMETER
*/
/*
* INTEGER_PARAMETER
*/
/*
* SIGNED_INTEGER_PARAMETER
*/
/*
* LONG_INTEGER_PARAMETER
*/
/*
* SIGNED_LONG_INTEGER_PARAMETER
*/
/*
* STRING_PARAMETER
*/
#define __S2_Episode_EA_RSP_v1_1_IP_ADDRESS_STRING_PARAMETER 10
#define __S2_Episode_EA_RSP_v1_1_USERNAME_STRING_PARAMETER 11
#define __S2_Episode_EA_RSP_v1_1_PASSWORD_STRING_PARAMETER 12
#define __S2_Episode_EA_RSP_v1_1_IP_ADDRESS_PARAM_MAX_LEN 18
CREATE_STRING_STRUCT( S2_Episode_EA_RSP_v1_1, __IP_ADDRESS, __S2_Episode_EA_RSP_v1_1_IP_ADDRESS_PARAM_MAX_LEN );
#define __S2_Episode_EA_RSP_v1_1_USERNAME_PARAM_MAX_LEN 32
CREATE_STRING_STRUCT( S2_Episode_EA_RSP_v1_1, __USERNAME, __S2_Episode_EA_RSP_v1_1_USERNAME_PARAM_MAX_LEN );
#define __S2_Episode_EA_RSP_v1_1_PASSWORD_PARAM_MAX_LEN 32
CREATE_STRING_STRUCT( S2_Episode_EA_RSP_v1_1, __PASSWORD, __S2_Episode_EA_RSP_v1_1_PASSWORD_PARAM_MAX_LEN );


/*
* INTEGER
*/
CREATE_INTARRAY1D( S2_Episode_EA_RSP_v1_1, __G_OUTPUT_MUTE, 16 );;


/*
* LONG_INTEGER
*/


/*
* SIGNED_INTEGER
*/


/*
* SIGNED_LONG_INTEGER
*/


/*
* STRING
*/

/*
* STRUCTURE
*/

START_GLOBAL_VAR_STRUCT( S2_Episode_EA_RSP_v1_1 )
{
   void* InstancePtr;
   struct GenericOutputString_s sGenericOutStr;
   unsigned short LastModifiedArrayIndex;

   DECLARE_IO_ARRAY( __SELECT_OUTPUT );
   DECLARE_IO_ARRAY( __SELECT_INPUT );
   DECLARE_IO_ARRAY( __OUTPUT_VOLUME_UP );
   DECLARE_IO_ARRAY( __OUTPUT_VOLUME_DOWN );
   DECLARE_IO_ARRAY( __MUTE_OUTPUT );
   DECLARE_IO_ARRAY( __SET_OUTPUT_VOLUME );
   DECLARE_IO_ARRAY( __OUTPUT_SOURCE );
   DECLARE_IO_ARRAY( __OUTPUT_VOLUME );
   unsigned short __G_SELECTED_OUTPUT;
   unsigned short __G_SELECTED_INPUT;
   DECLARE_INTARRAY( S2_Episode_EA_RSP_v1_1, __G_OUTPUT_MUTE );
   short __G_CONNECTIONSTATUS;
   short __G_SOCKETSTATUS;
   DECLARE_SOCKET( S2_Episode_EA_RSP_v1_1, __CLIENT );
   DECLARE_STRING_STRUCT( S2_Episode_EA_RSP_v1_1, __IP_ADDRESS );
   DECLARE_STRING_STRUCT( S2_Episode_EA_RSP_v1_1, __USERNAME );
   DECLARE_STRING_STRUCT( S2_Episode_EA_RSP_v1_1, __PASSWORD );
};

START_NVRAM_VAR_STRUCT( S2_Episode_EA_RSP_v1_1 )
{
};



#endif //__S2_EPISODE_EA_RSP_V1_1_H__

